add debug mode and some bug fixes

pull/20/head
Botspot 5 years ago
parent 41c963e7d3
commit ced4675a6d

@ -0,0 +1,3 @@
#Have manual control over apt processes for pkg-install and purge-installed
No
Yes

@ -53,6 +53,9 @@ if [ $exitcode != 0 ] || [ ! -z "$errors" ];then
exit 1
fi
#remove residual packages
sudo apt autoremove -y && sudo apt clean && sudo apt-get purge -y $(dpkg -l | grep '^rc' | awk '{print $2}')
output="$(sudo apt-get install --no-install-recommends --dry-run $PKG_LIST 2>&1)"
echo "output: $output"
@ -64,7 +67,7 @@ if [ ! -z "$errors" ];then
exit 1
fi
INSTALL_LIST="$(echo "$output" | sed -n '/The following NEW packages/,/to remove/p' | sed -e '2,$!d' -e '$d' | tr -d '*' | tr '\n' ' ')"
INSTALL_LIST="$(echo "$output" | sed -n '/The following NEW packages/,/to remove/p' | sed -e '2,$!d' -e '$d' | tr -d '*' | tr '\n' ' ' | sed 's/The following.*//')"
if [ ! -z "$INSTALL_LIST" ];then
#save that list of installed packages in the program directory for future removal
@ -72,9 +75,17 @@ if [ ! -z "$INSTALL_LIST" ];then
echo "$INSTALL_LIST" >> "${DIRECTORY}/data/installed-packages/${PRG}"
echo -e "These packages will be installed: \e[2m$INSTALL_LIST\e[22m"
output="$(sudo apt-get install -y --no-install-recommends $PKG_LIST 2>&1)"
exitcode=$?
#echo -e "Output was: ${output}\nEOO"
if [ "$(cat "${DIRECTORY}/data/settings/Debug mode")" == 'Yes' ];then
#debug mode
output="$(sudo apt-get install -y --no-install-recommends $PKG_LIST 1>&2)"
exitcode=$?
else
#normal mode
output="$(sudo apt-get install -y --no-install-recommends $PKG_LIST 2>&1)"
exitcode=$?
fi
echo 'Apt finished.'
errors="$(echo "$output" | grep '^[(W)|(E)|(Err]:')"
if [ $exitcode != 0 ] || [ ! -z "$errors" ];then
@ -91,7 +102,7 @@ if [ ! -z "$INSTALL_LIST" ];then
# INSTALL_LIST="${INSTALL_LIST} ${i}" #add package to install list
# fi
#done
INSTALL_LIST="$(sudo apt-get install --no-install-recommends --dry-run $PKG_LIST | sed -n '/The following packages/,/to remove/p' | sed -e '2,$!d' -e '$d' | tr -d '*' | tr '\n' ' ')"
INSTALL_LIST="$(sudo apt-get install --no-install-recommends --dry-run $PKG_LIST | sed -n '/The following packages/,/to remove/p' | sed -e '2,$!d' -e '$d' | tr -d '*' | tr '\n' ' ' | sed 's/The following.*//')"
if [ ! -z $INSTALL_LIST ];then

@ -39,13 +39,22 @@ if [ -z "${DIRECTORY}/data/installed-packages/${PRG}" ];then
exit 0
fi
PURGE_LIST="$(sudo apt-get purge --dry-run $PKG_LIST | sed -n '/The following packages will be REMOVED/,/to remove and/p' | sed -e '2,$!d' -e '$d' | tr -d '*' | tr '\n' ' ')"
#remove residual packages
sudo apt autoremove -y && sudo apt clean && sudo apt-get purge -y $(dpkg -l | grep '^rc' | awk '{print $2}')
PURGE_LIST="$(sudo apt-get purge --dry-run $PKG_LIST | sed -n '/The following packages will be REMOVED/,/to remove and/p' | sed -e '2,$!d' -e '$d' | tr -d '*' | tr '\n' ' ' | sed 's/The following.*//')"
echo "These packages will be purged: $PURGE_LIST"
output="$(sudo apt purge -y $PKG_LIST 2>&1)"
exitcode=$?
if [ "$(cat "${DIRECTORY}/data/settings/Debug mode")" == 'Yes' ];then
#debug mode
output="$(sudo apt purge -y $PKG_LIST 1>&2)"
exitcode=$?
else
#normal mode
output="$(sudo apt purge -y $PKG_LIST 2>&1)"
exitcode=$?
fi
errors="$(echo "$output" | grep '^[(W)|(E)|(Err]:')"
sudo apt autoremove -y && sudo apt clean && sudo apt-get purge -y $(dpkg -l | grep '^rc' | awk '{print $2}')
if [ $exitcode != 0 ] || [ ! -z "$errors" ];then
echo -e "\e[91mFailed to uninstall the packages!\e[39m"
echo -e "APT reported these errors:\n\e[91m$errors\e[39m"

Loading…
Cancel
Save